//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "ValidArea.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
bool mostrar = true;

sdefeito *novo;

int criando = 0;


//---------------------------------------------------------------------------
void LimpaDefeito (shorizontal *auxh) {

  svertical *inicio = auxh->idefv, *final = auxh->fdefv;

  svertical *aux = inicio;

  while (aux != final) {

    if (aux->acumulado <= -1) {
      aux->acumulado++;
      if (aux->acumulado == 0)
        aux->inicio_acumulado = auxh;
    }

    aux = aux->prox;
  }

}
//---------------------------------------------------------------------------
int CalcCelula (shorizontal *nodo) {

  if (!nodo)
    return 0;

  if (!nodo->prev)
    return 0;
  else
    return (nodo->coordh - nodo->prev->coordh);
}
//---------------------------------------------------------------------------
void AtualizaVerticais (svertical *v, shorizontal *auxh) {

  svertical *aux = v;

  int celula = CalcCelula (auxh);

  while (aux->prox) {
    if (aux->acumulado > -1) {
      aux->acumulado += celula;
      if (aux->acumulado == 0)
        aux->inicio_acumulado = auxh;
     }
    aux = aux->prox;
  }

}
//---------------------------------------------------------------------------
shorizontal *PegaH () {

  shorizontal *aux = new shorizontal;

  aux->coordh = 0;
  aux->prox = NULL;
  aux->prev = NULL;
  aux->idefv = NULL;
  aux->fdefv = NULL;

  return aux;
}
//---------------------------------------------------------------------------
svertical *PegaV () {

  svertical *aux = new svertical;

  aux->coordv = 0;
  aux->acumulado = 0;
  aux->inicio_acumulado = NULL;
  aux->prox = NULL;
  aux->prev = NULL;

  return aux;
}
//---------------------------------------------------------------------------
ssolucao *PegaS () {

  ssolucao *aux = new ssolucao;

  aux->inicio = NULL;
  aux->final = NULL;
  aux->atual = NULL;
  aux->comeco = NULL;
  aux->prox=NULL;
  aux->prev=NULL;

  return aux;
}
//---------------------------------------------------------------------------
ssolucao *TestaCima (svertical *v, svertical *extremo, shorizontal *atual) {

  // Se bateu na borda ento no d para gerar nova soluo

  if (!extremo->prev)
    return NULL;

  // Se extremo est dentro de um defeito

  if (extremo->prev->acumulado <= -1)
    return NULL;

  // Caso contrrio abre nova soluo

  svertical *aux = extremo;
  shorizontal *inicioh;
  int acumulado = MAX_BOB;

  while (aux->prev && (aux->prev->acumulado > -1)) {
    if (aux->prev->acumulado < acumulado) {
      acumulado = aux->prev->acumulado;
      inicioh = aux->prev->inicio_acumulado;
    }
    aux = aux->prev;
  }

  if (extremo == aux)
    return NULL;

  ssolucao *NovaS = PegaS ();

  NovaS->inicio = aux;
  NovaS->final = extremo;
  NovaS->comeco = inicioh;

  return NovaS;
}
//---------------------------------------------------------------------------
ssolucao *TestaBaixo (svertical *v, svertical *extremo, shorizontal *atual) {

  // Se bateu na borda ento no d para gerar nova soluo

  if (!extremo->prox)
    return NULL;

  // Caso contrrio abre nova soluo

  svertical *aux = extremo;
  shorizontal *inicioh;
  int acumulado = MAX_BOB;

  while (aux->prox && (aux->acumulado > -1)) {
    if (aux->acumulado < acumulado) {
      acumulado = aux->acumulado;
      inicioh = aux->inicio_acumulado;
    }
    aux = aux->prox;
  }

  if (extremo == aux)
    return NULL;

  ssolucao *NovaS = PegaS ();

  NovaS->inicio = extremo;
  NovaS->final = aux;
  NovaS->comeco = inicioh;

  return NovaS;
}
//---------------------------------------------------------------------------
ssolucao *TestaCimaBaixo (svertical *v, svertical *extremo,
         shorizontal *atual) {

  svertical *extremocima = extremo, *extremobaixo = extremo;
  shorizontal *inicioh;
  int acumulado = MAX_BOB;

  if (extremo->prev)
    // Se extremo est fora de um defeito
    if (extremo->prev->acumulado > -1) {
      // Procura ponto extremo
      svertical *aux = extremo;

      while (aux->prev && (aux->prev->acumulado > -1)) {
        if (aux->prev->acumulado < acumulado) {
          acumulado = aux->prev->acumulado;
          inicioh = aux->prev->inicio_acumulado;
        }
        aux = aux->prev;
      }
      extremocima = aux;
    }
  // Se bateu na borda

  if (extremo->prox) {

    // Procura ponto extremo
    svertical *aux = extremo;

    while (aux->prox && (aux->acumulado > -1)) {
      if (aux->acumulado < acumulado) {
        acumulado = aux->acumulado;
        inicioh = aux->inicio_acumulado;
      }
      aux = aux->prox;
    }
    extremobaixo = aux;

  }

  if (extremocima == extremobaixo)
    return NULL;

  ssolucao *NovaS = PegaS ();

  NovaS->inicio = extremocima;
  NovaS->final = extremobaixo;
  NovaS->comeco = inicioh;

  return NovaS;

}

ssolucao *retire (ssolucao **conjsol, ssolucao *nodo) {

  if (nodo->prev) {
    if (nodo->prox) {
      ssolucao *aux;

      nodo->prev->prox = nodo->prox;
      nodo->prox->prev = nodo->prev;
      aux = nodo->prox;
      delete nodo;
      return aux;
    } else {
      nodo->prev->prox = NULL;
      delete nodo;
      return NULL;
    }
  } else {
    if (nodo->prox) {
      ssolucao *aux;

      *conjsol = aux = nodo->prox;
      aux->prev = NULL;
      delete nodo;
      return aux;
    } else {
      delete nodo;
      *conjsol = NULL;
      return NULL;
    }
  }
}
//---------------------------------------------------------------------------
bool Desativa (ssolucao **conjsol, ssolucao **melhor, ssolucao *nodo,
               shorizontal *atual) {

  ssolucao *auxmelhor = *melhor;

  if (!nodo->atual)
    nodo->atual = atual;

  if (nodo->inicio->coordv == nodo->final->coordv ||
      nodo->comeco->coordh == nodo->atual->coordh) {
    return FALSE;
  }

  double inv = nodo->inicio->coordv,
         fnv = nodo->final->coordv,
         inh = nodo->comeco->coordh,
         fnh = nodo->atual->coordh;

  if ((fnv - inv) < AREA_Y || (fnh - inh) < AREA_X)
    return FALSE;

  if (!auxmelhor)
    *melhor = nodo;
  else {


    double imv = auxmelhor->inicio->coordv,
           fmv = auxmelhor->final->coordv,
           imh = auxmelhor->comeco->coordh,
           fmh = auxmelhor->atual->coordh,
           a, b;

    a = (fnv - inv) * (fnh - inh);
    b = (fmv - imv) * (fmh - imh);

    if (a > b) {
      nodo->atual = atual;
      *melhor = nodo;
    } else {
      return FALSE;
    }
  }
  return TRUE;
}
//---------------------------------------------------------------------------
void SetaComprLivre (svertical *iv, svertical *fv, int valor) {

  svertical *aux = iv;
  svertical *aux2 = fv;

  while (aux != aux2) {

    if (valor == -1)
      if (aux->acumulado > -1)
        aux->acumulado = -1;
      else
        aux->acumulado--;
    else
      aux->acumulado = valor;

    aux = aux->prox;
  }
}

//---------------------------------------------------------------------------
bool InsereSolucao (ssolucao **s, ssolucao *nodo,
     ssolucao *melhor, int compr_bob) {

  double inv = nodo->inicio->coordv,
         fnv = nodo->final->coordv,
         inh = nodo->comeco->coordh,
         fnh = compr_bob;

  if ((fnv - inv) < AREA_Y || (fnh - inh) < AREA_X) {
    delete nodo;
    return FALSE;
  }

  if (melhor) {

    double imv = melhor->inicio->coordv,
           fmv = melhor->final->coordv,
           imh = melhor->comeco->coordh,
           fmh = melhor->atual->coordh,
           a, b;

    a = (fnv - inv) * (fnh - inh);
    b = (fmv - imv) * (fmh - imh);

    if (a < b) {
      delete nodo;
      return FALSE;
    }
  }


  ssolucao *aux = *s;

  nodo->prox = aux;
  *s = nodo;
  if (nodo->prox)
    nodo->prox->prev = nodo;
  return TRUE;
}
//---------------------------------------------------------------------------
void InsereOrdenadoH (shorizontal**h, shorizontal*nodo) {

  shorizontal *aux = *h;

  if (!aux) {
    *h = nodo;
    return;
  } else
    if (!aux->prox) {
      if (nodo->coordh <= aux->coordh) {
        if (aux->estado == inicio_bobina) {
          aux->prox = nodo;
          nodo->prev = aux;
          return;
        } else {
          nodo->prox = aux;
          aux->prev = nodo;
          *h = nodo;
          return;
        }
      } else {
        aux->prox = nodo;
        nodo->prev = aux;
        return;
      }
    } else {
      if (nodo->coordh <= aux->coordh) {
        if (aux->estado == inicio_bobina) {
          nodo->prox = aux->prox;
          nodo->prox->prev;
          aux->prox = nodo;
          nodo->prev = aux;
          return;
        } else {
          nodo->prox = aux;
          aux->prev = nodo;
          *h = nodo;
          return;
        }
      } else
        while (aux->prox) {
          if (nodo->coordh <= aux->prox->coordh) {
            nodo->prox = aux->prox;
            aux->prox->prev = nodo;
            aux->prox = nodo;
            nodo->prev = aux;
            return;
          } else {
            aux = aux->prox;
            if (!aux->prox) {
              aux->prox = nodo;
              nodo->prev = aux;
              return;
            }
          }
        }
    }

}
//---------------------------------------------------------------------------
svertical *InsereOrdenadoV (svertical**v, svertical*nodo) {

  svertical *aux = *v;

  if (!aux) {
    *v = nodo;
    return nodo;
  } else
    if (!aux->prox) {
      if (nodo->coordv == aux->coordv) {
        delete nodo;
        return aux;
      }
      if (nodo->coordv <= aux->coordv) {
        nodo->prox = aux;
        aux->prev = nodo;
        *v = nodo;
        return nodo;
      } else {
        aux->prox = nodo;
        nodo->prev = aux;
        return nodo;
      }
    } else {
      if (nodo->coordv == aux->coordv) {
        delete nodo;
        return aux;
      }
      if (nodo->coordv <= aux->coordv) {
        nodo->prox = aux;
        aux->prev = nodo;
        *v = nodo;
        return nodo;
      } else
        while (aux->prox) {
          if (nodo->coordv == aux->prox->coordv) {
            delete nodo;
            return aux->prox;
          }
          if (nodo->coordv <= aux->prox->coordv) {
            nodo->prox = aux->prox;
            aux->prox->prev = nodo;
            aux->prox = nodo;
            nodo->prev = aux;
            return nodo;
          } else {
            aux = aux->prox;
            if (!aux->prox) {
              aux->prox = nodo;
              nodo->prev = aux;
              return nodo;
            }
          }
        }
    }
  return NULL;
}
//---------------------------------------------------------------------------
void Limpa (sdefeito **defeito, shorizontal **h,
            svertical **v, ssolucao **s) {

  sdefeito *aux = *defeito;
  while (aux) {
    *defeito = aux->prox;
    delete aux;
    aux = *defeito;
  }
  *defeito = NULL;

  shorizontal *auxh = *h;
  while (auxh) {
    *h = auxh->prox;
    delete auxh;
    auxh = *h;
  }
  *h = NULL;

  svertical *auxv = *v;
  while (auxv) {
    *v = auxv->prox;
    delete auxv;
    auxv = *v;
  }
  *v = NULL;

  ssolucao *auxs = *s;
  while (auxs) {
    *s = auxs->prox;
    delete auxs;
    auxs = *s;
  }
  *s = NULL;

}
//---------------------------------------------------------------------------
void Restaura (shorizontal **h, svertical **v, ssolucao **s) {

  shorizontal *auxh = *h;
  while (auxh) {
    *h = auxh->prox;
    delete auxh;
    auxh = *h;
  }
  *h = NULL;

  svertical *auxv = *v;
  while (auxv) {
    *v = auxv->prox;
    delete auxv;
    auxv = *v;
  }
  *v = NULL;

  ssolucao *auxs = *s;
  while (auxs) {
    *s = auxs->prox;
    delete auxs;
    auxs = *s;
  }
  *s = NULL;

}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  static i = 1;

  sbob_x1 = DESL_X1;
  sbob_x2 = Width - DESL_X2;
  sbob_y1 = DESL_Y1;
  sbob_y2 = Height - DESL_Y2;

  if (i) {
    v = NULL;
    h = NULL;
    defeito = NULL;
    conjsol = NULL;
    melhor = NULL;

    i = 0;
  }

  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormPaint(TObject *Sender)
{
  int x1, x2, y1, y2;

  sbob_x1 = DESL_X1;
  sbob_x2 = Width - DESL_X2;
  sbob_y1 = DESL_Y1;
  sbob_y2 = Height - DESL_Y2;

  Canvas->Brush->Color = clWindow;
  Canvas->Pen->Color = clGray;

  Canvas->Rectangle(sbob_x1, sbob_y1, sbob_x2, sbob_y2);

  if (melhor) {
    Canvas->Brush->Color = clBlue;
    Canvas->Pen->Color = clBlack;

    x1 = DESL_X1 + melhor->comeco->coordh * (sbob_x2 - sbob_x1) / (BOB_X2 - BOB_X1);
    y1 = DESL_Y1 + melhor->inicio->coordv * (sbob_y2 - sbob_y1) / (BOB_Y2 - BOB_Y1);
    x2 = DESL_X1 + melhor->atual->coordh * (sbob_x2 - sbob_x1) / (BOB_X2 - BOB_X1);
    y2 = DESL_Y1 + melhor->final->coordv * (sbob_y2 - sbob_y1) / (BOB_Y2 - BOB_Y1);

    Canvas->Rectangle(x1, y1, x2, y2);

  }

  Canvas->Brush->Color = clGray;
  Canvas->Pen->Color = clGray;

  sdefeito *aux = defeito;

  Canvas->Brush->Color = clRed;
  Canvas->Pen->Color = clBlack;

  while (aux) {

    x1 = DESL_X1 + aux->x1 * (sbob_x2 - sbob_x1) / (BOB_X2 - BOB_X1);
    y1 = DESL_Y1 + aux->y1 * (sbob_y2 - sbob_y1) / (BOB_Y2 - BOB_Y1);
    x2 = DESL_X1 + aux->x2 * (sbob_x2 - sbob_x1) / (BOB_X2 - BOB_X1);
    y2 = DESL_Y1 + aux->y2 * (sbob_y2 - sbob_y1) / (BOB_Y2 - BOB_Y1);

    Canvas->Rectangle(x1, y1, x2, y2);

    aux = aux->prox;
  }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormResize(TObject *Sender)
{
  Invalidate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Ler1Click(TObject *Sender)
{
  FILE *in;

  if ((in = fopen("\\DEFEITO.DAT", "rt")) == NULL) {
    Limpa (&defeito, &h, &v, &conjsol);
    Invalidate ();
    return;
  }

  while (!feof(in)) {

    int x1, x2, y1, y2;

    fscanf (in, "%d %d %d %d\n", &x1, &y1, &x2, &y2);

    if (x1 < BOB_X1 || x1 > BOB_X2 ||
        x2 < BOB_X1 || x2 > BOB_X2 ||
        y1 < BOB_Y1 || y1 > BOB_Y2 ||
        y2 < BOB_Y1 || y2 > BOB_Y2) {
      Limpa (&defeito, &h, &v, &conjsol);
      Invalidate ();
      return;
    }

    if (x1 != x2 && y1 != y2) {
      sdefeito *aux = defeito;
      defeito = new sdefeito;
      defeito->prox = aux;
      defeito->x1 = x1;
      defeito->x2 = x2;
      defeito->y1 = y1;
      defeito->y2 = y2;
    }
  }

   fclose(in);

   Executar1->Enabled = TRUE;
   Ler1->Enabled = FALSE;

   Invalidate ();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  Limpa (&defeito, &h, &v, &conjsol);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Sair1Click(TObject *Sender)
{
  Limpa (&defeito, &h, &v, &conjsol);
  exit (EXIT_SUCCESS);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Salvar1Click(TObject *Sender)
{
  FILE *out;

  if ((out = fopen("\\DEFEITO.DAT", "wt")) == NULL) {
    Limpa (&defeito, &h, &v, &conjsol);
    Invalidate ();
    return;
  }

  sdefeito *aux = defeito;

  while (aux) {
    fprintf (out, "%d %d %d %d\n", aux->x1, aux->y1, aux->x2, aux->y2);
    aux = aux ->prox;
  }

  fclose(out);
  Invalidate ();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Executar1Click(TObject *Sender)
{

  //
  // Arruma vetores H e V
  //

  // Arruma extremos da bobina

  shorizontal *ibobh = PegaH ();
  ibobh->coordh = BOB_X1;
  ibobh->estado = inicio_bobina;

  shorizontal *fbobh = PegaH ();
  fbobh->coordh = BOB_X2;
  fbobh->estado = final_bobina;

  svertical *ibobv = PegaV ();
  ibobv->coordv = BOB_Y1;
  ibobv = InsereOrdenadoV (&v, ibobv);

  svertical *fbobv = PegaV ();
  fbobv->coordv = BOB_Y2;
  fbobv = InsereOrdenadoV (&v, fbobv);

  // Inserir depois para poder setar qual vertical o horizontal
  // deve apontar.

  InsereOrdenadoH (&h, ibobh);
  InsereOrdenadoH (&h, fbobh);


  // Liga as corrdenadas horizontais da bobina
  // usando os ponteiros de defeitos.

  ibobh->idefv = ibobv;
  ibobh->fdefv = fbobv;

  fbobh->idefv = ibobv;
  fbobh->fdefv = fbobv;

  // Arruma extremos dos defeitos

  sdefeito *aux = defeito;

  while (aux) {

    shorizontal *ih, *fh;
    svertical *iv, *fv;

    if (aux->x1 > aux->x2) {
      int i = aux->x1;

      aux->x1 = aux->x2;
      aux->x2 = i;
    }
    if (aux->y1 > aux->y2) {
      int i = aux->y1;

      aux->y1 = aux->y2;
      aux->y2 = i;
    }

    ih = PegaH ();
    ih->coordh = aux->x1;
    ih->estado = inicio;

    fh = PegaH ();
    fh->coordh = aux->x2;
    fh->estado = final;

    iv = PegaV ();
    iv->coordv = aux->y1;

    fv = PegaV ();
    fv->coordv = aux->y2;

    // Atualizar qual ponteiro vertical o horizontal deve apontar

    fh->idefv = ih->idefv = InsereOrdenadoV (&v, iv);
    fh->fdefv = ih->fdefv = InsereOrdenadoV (&v, fv);
    InsereOrdenadoH (&h, ih);
    InsereOrdenadoH (&h, fh);

    aux=aux->prox;
  }

  //
  // Incio do Algoritmo
  //

  shorizontal *auxh;
  auxh = h;
  while (auxh) {

    // Se for incio de bobina ento gera uma soluo com toda a largura

    switch (auxh->estado) {

      case (inicio_bobina) : {

        ssolucao *NovaS = PegaS ();

        NovaS->inicio = auxh->idefv;
        NovaS->final = auxh->fdefv;
        NovaS->comeco = auxh;

        // Atualiza todos os verticais que esto vlidos

        AtualizaVerticais (v, h);


//        SetaComprLivre (NovaS->inicio, NULL, 0); // At o final

        InsereSolucao (&conjsol, NovaS, melhor, BOB_X2);

        break;
       }
      // Se for final de bobina ento finaliza todas as reas encontradas

      case (final_bobina) : {

        ssolucao *aux = conjsol;
        ssolucao *ant_melhor = melhor;

        while (aux) {

          if (aux != melhor)
            if (Desativa (&conjsol, &melhor, aux, auxh)) {
              if (ant_melhor)
                retire (&conjsol, ant_melhor);
              ant_melhor = melhor;
              if (mostrar)
                Invalidate ();
              aux = aux->prox;
            } else 
              aux = retire (&conjsol, aux);
          else
            aux = aux->prox;
        }
        break;
      }
      case (inicio) : {

        // Todas as solues com as coordenadas deste defeito devem
        // ser encerradas

        ssolucao *auxs = conjsol;
        ssolucao *ant_melhor = melhor;

        while (auxs) {
          // Se alguma soluo tem alguma coordenada dentro do defeito
          if (auxs->inicio->coordv >= auxh->idefv->coordv &&
              auxs->inicio->coordv <= auxh->fdefv->coordv) {
            if (auxs != melhor)
              if (Desativa (&conjsol, &melhor, auxs, auxh)) {
                if (ant_melhor)
                  retire (&conjsol, ant_melhor);
                ant_melhor = melhor;
                if (mostrar)
                  Invalidate ();
                auxs = auxs->prox;
              } else
                auxs = retire (&conjsol, auxs);
            else
              auxs = auxs->prox;
          } else
            if (auxs->final->coordv >= auxh->idefv->coordv &&
                auxs->final->coordv <= auxh->fdefv->coordv) {
              if (auxs != melhor)
                if (Desativa (&conjsol, &melhor, auxs, auxh)) {
                  if (ant_melhor)
                    retire (&conjsol, ant_melhor);
                  ant_melhor = melhor;
                  if (mostrar)
                    Invalidate ();
                  auxs = auxs->prox;
                } else
                  auxs = retire (&conjsol, auxs);
              else
                auxs = auxs->prox;
            } else // Se a soluo est englobando o defeito
              if (auxs->inicio->coordv < auxh->idefv->coordv &&
                auxs->final->coordv > auxh->fdefv->coordv)
                if (auxs != melhor)
                  if (Desativa (&conjsol, &melhor, auxs, auxh)) {
                    if (ant_melhor)
                      retire (&conjsol, ant_melhor);
                    ant_melhor = melhor;
                    if (mostrar)
                      Invalidate ();
                    auxs = auxs->prox;
                  } else
                    auxs = retire (&conjsol, auxs);
                else
                  auxs = auxs->prox;
              else
                auxs = auxs->prox;

        }

        // Todas as larguras representando o defeito devem ser setadas
        // para -1 indicando que se est sobre um defeito

        SetaComprLivre (auxh->idefv, auxh->fdefv, -1);

        // Atualiza todos os verticais que esto vlidos

        AtualizaVerticais (v, auxh);

        // Tenta criar uma nova soluo para cima

        ssolucao *teste = TestaCima (v, auxh->idefv, auxh);

        if (teste)
          InsereSolucao (&conjsol, teste, melhor, BOB_X2);

        // Tenta criar uma nova soluo para baixo

        teste = TestaBaixo (v, auxh->fdefv, auxh);

        if (teste)
          InsereSolucao (&conjsol, teste, melhor, BOB_X2);

        break;
      }
      case (final) : {

        // Atualiza todos os verticais que esto vlidos

        AtualizaVerticais (v, auxh);

        // Apaga os -1 ou mais dos defeitos atuais

        LimpaDefeito (auxh);

        // Tenta criar uma nova soluo para cima e tambm para baixo

        ssolucao *teste = TestaCimaBaixo (v, auxh->idefv, auxh);

        svertical *extremo_inferior = auxh->idefv;

        if (teste) {
          extremo_inferior = teste->final;
          InsereSolucao (&conjsol, teste, melhor, BOB_X2);
        }

        svertical *fim_defeito = auxh->fdefv;

        while (extremo_inferior->coordv < fim_defeito->coordv) {

           ssolucao *teste2 = TestaBaixo (v, extremo_inferior, auxh);

           if (teste2) {
              extremo_inferior = teste2->final;
              InsereSolucao (&conjsol, teste2, melhor, BOB_X2);
           } else
             extremo_inferior = extremo_inferior->prox;
        }
        break;
      }
    }
    auxh = auxh->prox;
  }

  Ler1->Enabled = FALSE;
  Executar1->Enabled = FALSE;

  Invalidate ();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Limpar1Click(TObject *Sender)
{
   Limpa (&defeito, &h, &v, &conjsol);

   melhor = NULL;

   Ler1->Enabled = TRUE;
   Executar1->Enabled = TRUE;


   Invalidate ();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseUp(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
  if (criando == 0)
    return;

  novo->x2 = (X - DESL_X1) * BOB_X2 / (sbob_x2 - sbob_x1);
  novo->y2 = (Y - DESL_Y1) * BOB_Y2 / (sbob_y2 - sbob_y1);
  if (novo->x2 < BOB_X1)
    novo->x2 = BOB_X1;
  if (novo->x2 > BOB_X2)
    novo->x2 = BOB_X2;
  if (novo->y2 < BOB_Y1)
    novo->y2 = BOB_Y1;
  if (novo->y2 > BOB_Y2)
    novo->y2 = BOB_Y2;
  criando = 0;
  if (novo->x1 == novo->x2 && novo->y1 == novo->y2) {
    sdefeito *eliminar = defeito;

    defeito = defeito->prox;
    delete eliminar;
  }
  criando = 0;
  Invalidate ();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
  if (criando == 1) {
    novo->x2 = (X - DESL_X1) * BOB_X2 / (sbob_x2 - sbob_x1);
    novo->y2 = (Y - DESL_Y1) * BOB_Y2 / (sbob_y2 - sbob_y1);
    if (novo->x2 < BOB_X1)
      novo->x2 = BOB_X1;
    if (novo->x2 > BOB_X2)
      novo->x2 = BOB_X2;
    if (novo->y2 < BOB_Y1)
      novo->y2 = BOB_Y1;
    if (novo->y2 > BOB_Y2)
      novo->y2 = BOB_Y2;
    criando = 0;
    if (novo->x1 == novo->x2 && novo->y1 == novo->y2) {
      sdefeito *eliminar = defeito;

      defeito = defeito->prox;
      delete eliminar;
    }

    return;
  }

  novo = new sdefeito;
  novo->x1 = (X - DESL_X1) * BOB_X2 / (sbob_x2 - sbob_x1);
  novo->y1 = (Y - DESL_Y1) * BOB_Y2 / (sbob_y2 - sbob_y1);
  if (novo->x1 < BOB_X1)
    novo->x1 = BOB_X1;
  if (novo->x1 > BOB_X2)
    novo->x1 = BOB_X2;
  if (novo->y1 < BOB_Y1)
    novo->y1 = BOB_Y1;
  if (novo->y1 > BOB_Y2)
    novo->y1 = BOB_Y2;
  novo->prox = defeito;
  defeito = novo;
  criando = 1;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormMouseMove(TObject *Sender, TShiftState Shift, int X,
	int Y)        //  sx2 - sx1 --- maxbob
{       //    X          quero

  if (criando) {
    Canvas->Brush->Color = clBlue;
    Canvas->Pen->Color = clBlack;
    novo->x2 = (X - DESL_X1) * BOB_X2 / (sbob_x2 - sbob_x1);
    novo->y2 = (Y - DESL_Y1) * BOB_Y2 / (sbob_y2 - sbob_y1);
    if (novo->x2 < BOB_X1)
      novo->x2 = BOB_X1;
    if (novo->x2 > BOB_X2)
      novo->x2 = BOB_X2;
    if (novo->y2 < BOB_Y1)
      novo->y2 = BOB_Y1;
    if (novo->y2 > BOB_Y2)
      novo->y2 = BOB_Y2;
   if (Refresh1->Checked == false) {
      Canvas->Brush->Color = clRed;
      Canvas->Pen->Color = clBlack;

      int x1, y1, x2, y2;

        x1 = DESL_X1 + novo->x1 * (sbob_x2 - sbob_x1) / (BOB_X2 - BOB_X1);
        y1 = DESL_Y1 + novo->y1 * (sbob_y2 - sbob_y1) / (BOB_Y2 - BOB_Y1);
        x2 = DESL_X1 + novo->x2 * (sbob_x2 - sbob_x1) / (BOB_X2 - BOB_X1);
        y2 = DESL_Y1 + novo->y2 * (sbob_y2 - sbob_y1) / (BOB_Y2 - BOB_Y1);

        Canvas->Rectangle(x1, y1, x2, y2);
    } else
     Invalidate ();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Restaurar1Click(TObject *Sender)
{
  Restaura (&h, &v, &conjsol);
  Executar1->Enabled = TRUE;
  h = NULL;
  v = NULL;
  conjsol = NULL;
  melhor = NULL;
  Invalidate ();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Refresh1Click(TObject *Sender)
{
  Refresh1->Checked = !Refresh1->Checked;
}
//---------------------------------------------------------------------------

